#used for *all* guns
## Getting Gun Stats
execute store result score gbg.gun_version gbg.temp run data get entity @s SelectedItem.components.minecraft:custom_data.gbg_gun_version
execute store result score gbg.current_ammo gbg.temp run data get entity @s SelectedItem.components.minecraft:custom_data.gbg_current_ammo
execute store result score gbg.max_ammo gbg.temp run data get entity @s SelectedItem.components.minecraft:custom_data.gbg_max_ammo
execute store result score gbg.damage gbg.temp run data get entity @s SelectedItem.components.minecraft:custom_data.gbg_damage
execute store result score gbg.range gbg.temp run data get entity @s SelectedItem.components.minecraft:custom_data.gbg_range
execute store result score gbg.fire_rate gbg.temp run data get entity @s SelectedItem.components.minecraft:custom_data.gbg_fire_rate
#stopping funciton if out of ammo
execute if score gbg.current_ammo gbg.temp matches ..0 unless score gbg.max_ammo gbg.temp matches 0 run return fail

## Playing Sound
data modify storage gbg:sounds sound set from entity @s SelectedItem.components.minecraft:custom_data.gbg_shoot_sound
function gbg:misc/calculate_volume
execute store result storage gbg:sounds volume float 0.01 run scoreboard players get gbg.shoot_sound_volume gbg.temp
function gbg:gun/shoot_sound with storage gbg:sounds

## Updating Lore and Components
scoreboard players remove gbg.current_ammo gbg.temp 1
#calculating percent of durability gun should have
function gbg:misc/calculate_durability
execute store result storage gbg:stats tag.current_ammo int 1 run scoreboard players get gbg.current_ammo gbg.temp
execute store result storage gbg:stats tag.new_durability float 0.01 run scoreboard players get gbg.new_durability gbg.temp
#calculating gun damage for explosive weapons
execute store result score gbg.damage_type gbg.temp run data get entity @s SelectedItem.components.minecraft:custom_data.gbg_damage_type
execute if score gbg.damage_type gbg.temp matches 2..3 run function gbg:misc/calculate_damage
execute if score gbg.damage_type gbg.temp matches 7 run function gbg:misc/calculate_damage
#re-building lore and updating components
execute unless score gbg.max_ammo gbg.temp matches ..0 run item modify entity @s weapon.mainhand gbg:build_lore_reg
execute if score gbg.max_ammo gbg.temp matches ..0 run item modify entity @s weapon.mainhand gbg:build_lore_ammoless

## Shooting Projectile
#all the cute preliminary stuff
execute store result score gbg.damage gbg.temp run data get entity @s SelectedItem.components.minecraft:custom_data.gbg_damage
tag @s add gbg.gun_shooter
scoreboard players operation @s gbg.cooldown = gbg.fire_rate gbg.temp
execute store result storage gbg:macro input.source int 1 run scoreboard players get @s gbg.id
data modify storage gbg:macro input.gun_name set from entity @s SelectedItem.components.minecraft:custom_name
scoreboard players operation gbg.range gbg.temp *= 5 number
#running the right raycast
execute store result score gbg.projectile_type gbg.temp run data get entity @s SelectedItem.components.minecraft:custom_data.gbg_projectile_type
execute if score gbg.projectile_type gbg.temp matches 1 run function gbg:gun/raycast/projectile/bullet
execute if score gbg.projectile_type gbg.temp matches 3 run function gbg:gun/raycast/projectile/fire
execute if score gbg.projectile_type gbg.temp matches 4 run function gbg:gun/raycast/projectile/blaze_fire
execute if score gbg.projectile_type gbg.temp matches 5 run function gbg:gun/raycast/projectile/laser
execute if score gbg.projectile_type gbg.temp matches 6 run function gbg:gun/raycast/projectile/large_laser
execute if score gbg.projectile_type gbg.temp matches 7 run function gbg:gun/raycast/projectile/green
execute if score gbg.projectile_type gbg.temp matches 8 run function gbg:gun/raycast/projectile/blue
execute if score gbg.projectile_type gbg.temp matches 9 run function gbg:gun/raycast/projectile/pink
execute if score gbg.projectile_type gbg.temp matches 10 run function gbg:gun/raycast/projectile/red
execute if score gbg.projectile_type gbg.temp matches 11 run function gbg:gun/raycast/projectile/light
execute if score gbg.projectile_type gbg.temp matches 12 run function gbg:gun/raycast/projectile/purple
execute if score gbg.projectile_type gbg.temp matches 13 run function gbg:gun/raycast/projectile/bullet_light
execute if score gbg.projectile_type gbg.temp matches 14 run function gbg:gun/raycast/projectile/pellets
#running the right slowcast
execute if score gbg.projectile_type gbg.temp matches 2 run function gbg:gun/slowcast/launch
execute if score gbg.projectile_type gbg.temp matches 15..16 run function gbg:gun/slowcast/launch

## Setting Recoil
#getting different value if player is aiming with gun
execute store result score gbg.recoil_strength gbg.temp run data get entity @s SelectedItem.components.minecraft:custom_data.gbg_recoil_strength
execute if score @s gbg.is_zooming matches 1 if score gbg.gun_version gbg.temp matches 2.. store result score gbg.recoil_strength gbg.temp run data get entity @s SelectedItem.components.minecraft:custom_data.gbg_zoom_recoil_strength
#applying camera movment
execute if score gbg.recoil_strength gbg.temp matches 4 run tp @s ~ ~ ~ ~ ~-0.4
execute if score gbg.recoil_strength gbg.temp matches 1 run tp @s ~ ~ ~ ~ ~-0.7
execute if score gbg.recoil_strength gbg.temp matches 5 run tp @s ~ ~ ~ ~ ~-1
execute if score gbg.recoil_strength gbg.temp matches 6 run tp @s ~ ~ ~ ~ ~-2
execute if score gbg.recoil_strength gbg.temp matches 2 run tp @s ~ ~ ~ ~ ~-3
execute if score gbg.recoil_strength gbg.temp matches 7 run tp @s ~ ~ ~ ~ ~-4
execute if score gbg.recoil_strength gbg.temp matches 3 run tp @s ~ ~ ~ ~ ~-5
execute if score gbg.recoil_strength gbg.temp matches 8 run tp @s ~ ~ ~ ~ ~-6
execute if score gbg.recoil_strength gbg.temp matches 9 run tp @s ~ ~ ~ ~ ~-7
execute if score gbg.recoil_strength gbg.temp matches 10 run tp @s ~ ~ ~ ~ ~-8

## Shooting Additional Projectiles
#only does this if the fire rate = 1
execute if score gbg.fire_rate gbg.temp matches 1 unless score @s gbg.burst_duration matches 1.. run scoreboard players set @s gbg.burst_duration 4

